<!doctype html>
<html>
    <head>
        <meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1, maximum-scale=1">          
        
        <!-- jQuery -->
        <script src="https://cdn.jsdelivr.net/npm/jquery@3.3.1/dist/jquery.min.js" type="text/javascript"></script>
        
        <!-- nanogallery2 -->
        <link  href="https://cdn.jsdelivr.net/npm/nanogallery2@3/dist/css/nanogallery2.min.css" rel="stylesheet" type="text/css">
        <script  type="text/javascript" src="https://cdn.jsdelivr.net/npm/nanogallery2@3/dist/jquery.nanogallery2.min.js"></script>
        <style>
            body { background: black;color: white;}
            .nGY2ViewerMediaPan.imgCurrent {
                image-rendering: pixelated;
            }
            .nGY2GThumbnail {
                image-rendering: pixelated;
            }
        </style>
    </head>
    <body>
    
            <h1>Webliero-Builder Maps</h1>

            <!-- ### position of the gallery ### -->
            <div id="nanogallery2">maps made using dsds's builder room on webliero.com</div>
        
            <script>
                $(async () => {
                    $.ajaxSetup({ cache: false });
                    let data = await $.getJSON('https://sylvodsds.gitlab.io/webliero-builder-maps/index.json')                    
                    let logs = await $.getJSON('https://sylvodsds.gitlab.io/webliero-builder-maps/logs.json')

                    var metas = new Map()
                
                    for (const l of logs ) {
                        if (l.subject && l.date) {
                            const sub =  [...l.subject.matchAll(/^adds\s(.*\.png)\sby\s(.*)$/gi)][0]                                                       
                            if (sub && sub.length==3) {
                                metas.set(sub[1], {author:sub[2], date:Date.parse(l.date)})
                            }
                            
                        }                        
                    } 
                    /* old maps */                   
                    metas.set('dei.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_10_28.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_2.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_again_i_guess.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_arena.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_labyrinth.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_niceone_destroyed_version.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('dei_niceone_fixed_version.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('deireversed.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('detuned.png', {author: 'dsds💚[ASS]'})
                    metas.set('jambon+sambeanooo.png', {author: '[str8]jambon0627 🐀+sambeanooo'})
                    metas.set('jambon.png', {author: '[str8]jambon0627 🐀'})
                    metas.set('kangur_writing_contest.png', {author: 'kangur+dsds💚[ASS]+abw12'})
                    metas.set('linemap.png', {author: 'PACER'})
                    metas.set('linemap2.png', {author: 'PACER'})
                    //metas.set('pacer_small.png', {author: 'PACER'})
                    metas.set('rysiek-parkur.png', {author: 'MightyRysiek'})
                    metas.set('rysiek-parkur_2.png', {author: 'MightyRysiek'})
                    metas.set('rysiek-parkur_3_epic_jump.png', {author: 'MightyRysiek'})
                    metas.set('snowman_small.png', {author: 'PACER+snowman'})
                    metas.set('some_map.png', {author: 'dsds💚[ASS]'})
                    metas.set('some_map_evolved.png', {author: 'dsds💚[ASS]'})
                    metas.set('test.png', {author: 'dsds💚[ASS]',date: new Date(1640899601000)})
                    metas.set('detuned.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/2xkross_.PNG', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/Saloon.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/angel.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/arkham.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/atr.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/duel.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/india2.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/panther-s.png', {author: 'dsds💚[ASS]'})
                    metas.set('bestarenas/cathod.PNG', {author: 'dsds💚[ASS]'})

                    let d = data.map((e)=>{
                        const a = e.split("/")
                        const folder = a.length>2?a[1]:''   
                        const filename = a[a.length-1]
                        const fullfilename = folder+(folder?'/':'')+filename
                        const name = filename.replace(/\.png$/i,'').replace(/^([A-Z]+)_s_/i, "$1's ").replace('_', ' ')
                        const author = metas.has(fullfilename)? metas.get(fullfilename).author : null
                        const dd   = metas.has(fullfilename)? metas.get(fullfilename).date??0 : 0
                        let tags = []
                        if (folder) tags.push(folder)
                        if (author) tags.push(author.replaceAll(' ','_'))
                        let description = ''
                        if (author) description+=`by ${author}`
                        if (dd) description+=((description.length)?' ':'')+`on ${(new Date(dd).toUTCString())}`

                        return {
                                src: e,
                                customData: {filename:(folder!=''?folder+'/':'')+filename,},
                                title: name+(folder?` [${folder}]`:''),
                                sort: dd,
                                description: description,
                                tags: tags.join(' ')
                        }
                    })
                    d.sort((a,b) => (a.sort > b.sort) ? -1 : ((b.sort > a.sort) ? 1 : 0))

                    $("#nanogallery2").nanogallery2( {
                        // ### gallery settings ###                 
                        itemsBaseURL:     'https://sylvodsds.gitlab.io/webliero-builder-maps/',
                        
                        // ### gallery content ### 
                        items: d,
                                    
                        // GALLERY AND THUMBNAIL LAYOUT
                        thumbnailHeight: '250', thumbnailWidth: 'auto',
                        thumbnailAlignment: 'fillWidth',
                        thumbnailL1GutterWidth: 20,
                        thumbnailL1GutterHeight: 20,
                        thumbnailBorderHorizontal: 1,
                        thumbnailBorderVertical: 1,

                        // THUMBNAIL TOOLS & LABEL
                        thumbnailL1Label: { display: true, position:'overImageOnTop', hideIcons: true, titleFontSize: '1.2em', align: 'left', displayDescription: true, descriptionFontSize: '0.8em'},
                        thumbnailToolbarImage :  { topLeft: 'select', topRight:'custom1',bottomRight : 'featured,display,download,info' },
                        icons:                      { 
                           thumbnailCustomTool1 : "#custom1#"
                        },
                        fnThumbnailInit:            myTnInit,
                        // DISPLAY ANIMATION
                        thumbnailDisplayTransition: 'flipUp',       // thumbnail display animation
                        thumbnailDisplayTransitionDuration: 400,
                        thumbnailDisplayInterval: 200,
                        thumbnailDisplayOrder: 'rowByRow',

                        // KEYWORD FILTERING
                        galleryFilterTags: true,
                        galleryFilterTagsMode: 'multiple',

                        // GALLERY THEME
                        galleryTheme : { 
                            thumbnail: { titleShadow : '', descriptionShadow : '', titleColor: '#fff', borderColor: '#000' },
                            navigationPagination :  { background: '#3C4B5B', color: '#fff', colorHover: '#aaa', borderRadius: '4px' },
                            navigationFilter: { background : '#003C3F', backgroundSelected: '#2E7C7F', color: '#fff' },
                            navigationBreadcrumb: { background : '#3C4B5B' },
                        },
                        viewerTools:    {
                            topLeft:   'label, description',
                            topRight:  'downloadButton, info, rotateLeft, rotateRight, fullscreenButton, closeButton'
                        },                    
                                  // callback to customize the content of the media info popup
                        fnPopupMediaInfo: my_popup_info,
                    });
                    function myTnInit( $e, item, GOMidx ) {                              
                        const e =  $e.find('.nGY2GThumbnailSub')               
                        const r = e.html().replace("#custom1#", d.length-item.mediaNumber);                    
                        e.html(r)
                    }
                    function my_popup_info(item, title, content){
                        console.log(item)
                        console.log(title)
                        console.log(content)
                        
                        var my_title = `<div class="nGY2PopupOneItem">${item.title}</div>`;
                        var my_content = `<div class="nGY2PopupOneItemText">${item.description}</div><div class="nGY2PopupOneItem">!mapi ${d.length-item.mediaNumber}</div><hr><div class="nGY2PopupOneItem">!map ${item.customData.filename}</div>`;
                        return {title: my_title, content: my_content};
                    }

                });
                      

           
            </script>

    </body>
</html>
